*** linux.orig/drivers/block/genhd.c	Tue Feb  2 01:25:53 1999
--- linux/drivers/block/genhd.c	Tue Mar 30 18:10:07 1999
***************
*** 776,786 ****
--- 776,789 ----
  #endif /* CONFIG_SUN_PARTITION */
  
  #ifdef CONFIG_SGI_PARTITION
+ #include <asm/byteorder.h>
  
  static int sgi_partition(struct gendisk *hd, kdev_t dev, unsigned long first_sector)
  {
  	int i, csum;
  	unsigned int *ui;
+ 	unsigned int start, blocks, cs;
+ 	int magic;
  	struct buffer_head *bh;
  	struct sgi_disklabel {
  		int magic_mushroom;         /* Big fat spliff... */
***************
*** 810,824 ****
  	}
  	label = (struct sgi_disklabel *) bh->b_data;
  	p = &label->partitions[0];
! 	if(label->magic_mushroom != SGI_LABEL_MAGIC) {
  		printk("Dev %s SGI disklabel: bad magic %08x\n",
! 		       kdevname(dev), label->magic_mushroom);
  		brelse(bh);
  		return 0;
  	}
  	ui = ((unsigned int *) (label + 1)) - 1;
! 	for(csum = 0; ui >= ((unsigned int *) label);)
! 		csum += *ui--;
  	if(csum) {
  		printk("Dev %s SGI disklabel: csum bad, label corrupted\n",
  		       kdevname(dev));
--- 813,830 ----
  	}
  	label = (struct sgi_disklabel *) bh->b_data;
  	p = &label->partitions[0];
! 	magic = label->magic_mushroom;
! 	if(be32_to_cpu(magic) != SGI_LABEL_MAGIC) {
  		printk("Dev %s SGI disklabel: bad magic %08x\n",
! 		       kdevname(dev), magic);
  		brelse(bh);
  		return 0;
  	}
  	ui = ((unsigned int *) (label + 1)) - 1;
! 	for(csum = 0; ui >= ((unsigned int *) label);) {
! 		cs = *ui--;
! 		csum += be32_to_cpu(cs);
! 	}
  	if(csum) {
  		printk("Dev %s SGI disklabel: csum bad, label corrupted\n",
  		       kdevname(dev));
***************
*** 831,839 ****
  	 * current_minor.
  	 */
  	for(i = 0; i < 16; i++, p++) {
! 		if(!(p->num_blocks))
  			continue;
! 		add_partition(hd, current_minor, p->first_block, p->num_blocks);
  		current_minor++;
  	}
  	printk("\n");
--- 837,847 ----
  	 * current_minor.
  	 */
  	for(i = 0; i < 16; i++, p++) {
! 		blocks = be32_to_cpu(p->num_blocks);
! 		start  = be32_to_cpu(p->first_block);
! 		if(!blocks)
  			continue;
! 		add_partition(hd, current_minor, start, blocks);
  		current_minor++;
  	}
  	printk("\n");
